function ramp(color, set1, max_val,conId) {

	var canvas = d3.select(conId)
		.append('canvas')
		.attr('width',800)
		.attr('height',100)

		canvas.style.margin = "0-14px";
	canvas.style.width = "100%";
	canvas.style.height = "200%";
	canvas.style.imageRendering = "pixelated";
	var context = canvas.node().getContext('2d');
	n = set1.size
		var iterator1 = set1.values();
	var c = iterator1.next().value
		c = iterator1.next().value

		context.font = "12px Arial";
	context.beginPath();
	context.moveTo(0, 20);
	context.lineTo(0, 25);
	context.stroke();
	context.fillText(c,0,35);
	var prev_val = 0
		for (let i = 0; i < n; ++i) {
			prev_val = c
				//console.log(c)
				context.fillStyle = color(c);
			context.fillRect(i, 0, 1, 20);
			c = iterator1.next().value
		}
	context.beginPath();
	context.moveTo(n, 20);
	context.lineTo(n, 25);
	context.stroke();
	context.fillText(max_val,n,35);

	console.log("MAX VALUE",max_val)

		return canvas;
}

function get_salary_var(salary_type , d){
	if(salary_type == "hhinc10k"){
		return d.hhinc10k
	}
	if(salary_type == "hhinc20k"){
		return d.hhinc20k
	}
	if(salary_type == "hhinc30k"){
		return d.hhinc30k
	}
	if(salary_type == "hhinc40k"){
		return d.hhinc40k
	}
	if(salary_type == "hhinc50k"){
		return d.hhinc50k
	}
	if(salary_type == "hhinc60k"){
		return d.hhinc60k
	}
	if(salary_type == "hhinc70k"){
		return d.hhinc70k
	}
	if(salary_type == "hhinc80k"){
		return d.hhinc80k
	}
	if(salary_type == "hhinc90k"){
		return d.hhinc90k
	}
	if(salary_type == "hhinc100k"){
		return d.hhinc100k
	}
	if(salary_type == "hhinc110k"){
		return d.hhinc110k
	}
	if(salary_type == "hhinc120k"){
		return d.hhinc120k
	}
}

function createMap(data, csv_data ,divId, projection, w, h , salary_type,conId) {

	//Create SVG element
	var mapSvg = d3.select(divId).append("svg")
		.attr("width", w)
		.attr("height", h);

	var path = d3.geoPath()
		.projection(projection);

	var dict_30 = {}
	var arr_30 = []
		var arr_80 = []
		var max_val = -1.0
		count = 0
		data.features.forEach(function(city){
		  csv_data.forEach(function(d){
			if (city.properties.TOWN_ID == d.muni_id){
			  if (get_salary_var(salary_type,d) != ""){
				console.log("It's empty")
				arr_30.push(parseFloat(get_salary_var(salary_type , d)))
				}
				dict_30[city.properties.TOWN_ID] = parseFloat(get_salary_var(salary_type,d))
				//dict_80[city.properties.TOWN_ID] = parseFloat(d.hhinc80k)
				//arr_80.push(d.hhinc80k)
				if (parseFloat(get_salary_var(salary_type,d)) > max_val){
					max_val = parseFloat(get_salary_var(salary_type,d))
				}
			}
		})
		})
	var colorScale = d3.scaleDiverging(function(t) {
			if (t == ""){
			return "black"
			}
			return d3.hsl(0.6, (5*t/max_val) , 0.8) + "";
			});

	//WARN: DON:T REMOVE
	arr_30.sort(function(a,b) { return a - b;})

		var set1 = new Set(arr_30)
		console.log(set1)

		console.log("HERE:")
		console.log(max_val)


		mapSvg.append("g")
		//.attr("class", "counties")
		.selectAll("path")
		.data(data.features)
		.enter().append("path")
		.attr("d", path)
		.style("fill", function(d){
				return colorScale(dict_30[d.properties.TOWN_ID])
				})
	.style("stroke", "black");

	ramp(colorScale,set1,max_val,conId)
		//console.log(dict_30.length)

		var umassd = [-71.006232, 41.629850];
	var boston = [-71.054754, 42.366031];
	var places = [umassd, boston];
	console.log(projection(umassd))

		/*  mapSvg.selectAll("circle")
		    .data(places)
		    .enter().append("circle")
		    .attr("cx", function(d) { return projection(d)[0]})
		    .attr("cy", function(d) { return projection(d)[1]})
		    .attr("r", 10)
		    .style("fill", "red");*/
}
console.log("Line 1")
//var map = L.map("mapid", {center: [37.8, -96.9], zoom: 4})
var map = L.map("mapid", {center: [42.162767, -71.138675], zoom: 7.5 , zoomControl:false })
    .addLayer(new L.TileLayer("http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"));

var svg = d3.select(map.getPanes().overlayPane).append("svg"),
    g = svg.append("g").attr("class", "leaflet-zoom-hide");

function projectPoint(x, y) {
  var point = map.latLngToLayerPoint(new L.LatLng(y, x));
    this.stream.point(point.x, point.y);
    }

//var salary_type = "hhinc80k"
function processData(bothdata,salary_type) {
       var salary_type = "hhinc80k"
       data = bothdata[0]
       csv_data = bothdata[1]
       console.log(data)
	var transform = d3.geoTransform({point: projectPoint}),
	    path = d3.geoPath().projection(transform);

	var dict_30 = {}
	var arr_30 = []
		var arr_80 = []
		var max_val = -1.0
		count = 0
		data.features.forEach(function(city){
		  csv_data.forEach(function(d){
			if (city.properties.TOWN_ID == d.muni_id){
			  if (get_salary_var(salary_type,d) != ""){
				console.log("It's empty")
				arr_30.push(parseFloat(get_salary_var(salary_type , d)))
				}
				dict_30[city.properties.TOWN_ID] = parseFloat(get_salary_var(salary_type,d))
				//dict_80[city.properties.TOWN_ID] = parseFloat(d.hhinc80k)
				//arr_80.push(d.hhinc80k)
				if (parseFloat(get_salary_var(salary_type,d)) > max_val){
					max_val = parseFloat(get_salary_var(salary_type,d))
				}
			}
		})
		})
	var colorScale = d3.scaleDiverging(function(t) {
			if (t == ""){
			return "black"
			}
			return d3.hsl(0.6, (5*t/max_val) , 0.8) + "";
			});

	//WARN: DON:T REMOVE
	arr_30.sort(function(a,b) { return a - b;})

		var set1 = new Set(arr_30)
		console.log(set1)

		console.log("HERE:")
		console.log(max_val)

		//.attr("class", "counties")
		var feature = g.selectAll("path")
		.data(data.features)
		.enter().append("path")


/*	var feature = g.selectAll("path")
		.data(data.features)
		.enter().append("path");*/

	map.on("viewreset", reset);
	reset();

	// Reposition the SVG to cover the features.
	function reset() {
		var bounds = path.bounds(data),
		    topLeft = bounds[0],
		    bottomRight = bounds[1];
		     console.log(bounds)

		    svg.attr("width", bottomRight[0] - topLeft[0])
			    .attr("height", bottomRight[1] - topLeft[1])
			    .style("left", topLeft[0] + "px")
			    .style("top", topLeft[1] + "px");

		    g.attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");
		    feature
		    .attr("d", path)
		       .style("fill", function(d){
				return colorScale(dict_30[d.properties.TOWN_ID])
				})
	             .style("stroke", "black");

;

}
}
// load the data from a web site, and once it is loaded, call a function to update the visualization
Promise.all([d3.json("https://gist.githubusercontent.com/dakoop/69c31771a040f8be86d73e7b31de6528/raw/daf94ffbe5ff7740cd92e4f5691a33b05a4ecc1b/ma-towns.json"),
               d3.csv("https://gist.githubusercontent.com/dakoop/69c31771a040f8be86d73e7b31de6528/raw/daf94ffbe5ff7740cd92e4f5691a33b05a4ecc1b/ma-housing-affordability.csv")])
		                .then(processData);

//d3.json("https://gist.githubusercontent.com/dakoop/69c31771a040f8be86d73e7b31de6528/raw/daf94ffbe5ff7740cd92e4f5691a33b05a4ecc1b/ma-towns.json").then(processData);
